﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.3
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region
'------------------------------------------------
Sub Process_Globals

Public manager As BleManager2
Public currentStateText As String = "UNKNOWN"
Public currentState As Int
Public connected As Boolean = False
Public ConnectedName As String
Public TimeConnected As Long
Public TimeDiscon As Long
Public ConnId As String
Public ConnRetry As Int
Public WriteStatus As Int
Public msgLen As Int			' for sendStr
Public msgPtr As Int			' for sendStr
Public msgPkt As String 		' for sendStr
Public msgAll As String
Public CR_LF As String = Chr(13) & Chr(10)

Public Name0 As String = "MY_4020"
'Public Name1 As String = "Biscuit"
Public Name1 As String = "MyBleVT"
'Public Name2 As String = "LAIRD BL600"
'Public Name3 As String = "LT_UPASS"
'Public Name4 As String = "RN5261"

'Private Service For Microchip MLDP
'Characteristic For MLDP Data, properties - notify, write
'''below to connect to BLE Nano Kit WORKS, name= 'Biscuit'.
'''Private MLDP_PRIVATE_SERVICE As String = "00035b03-58e6-07dd-021a-08123a000300" 'original for RN4020
'''Private MLDP_DATA_PRIVATE_CHAR As String = "00035b03-58e6-07dd-021a-08123a000301" 'original for RN4020

'''''''''''''Test: below to connect to BLE Nano Kit WORKS, name= 'Biscuit'.
'''''''''''''THIS IS CALLED generic access service
''''''''''''Private MLDP_PRIVATE_SERVICE As String =   "00001800-0000-1000-8000-00805f9b34fb"   'original for BLE Nano Kit
'''''''''''''THIS IS CALLED generic attribute service
'''''''''''''Private MLDP_DATA_PRIVATE_CHAR As String =   "00002a05-0000-1000-8000-00805f9b34fb"   'original for BLE Nano Kit
''''''''''''Private MLDP_DATA_PRIVATE_CHAR As String =   "00001801-0000-1000-8000-00805f9b34fb"   'original for BLE Nano Kit
''''''''''''

' The Nordic UART Service
Private MLDP_PRIVATE_SERVICE As String =     "713d0000-503e-4c75-ba94-3148f18d941e" 
'Private MLDP_DATA_PRIVATE_CHAR As String =   "713d0002-503e-4c75-ba94-3148f18d941e"   'RX
Private MLDP_DATA_PRIVATE_CHAR As String =   "713d0003-503e-4c75-ba94-3148f18d941e"   'TX
'static const uint8_t uart_base_uuid[] = {0x71, 0x3D, 0, 0, 0x50, 0x3E, 0x4C, 0x75, 0xBA, 0x94, 0x31, 0x48, 0xF1, 0x8D, 0x94, 0x1E};
'static const uint8_t uart_tx_uuid[]   = {0x71, 0x3D, 0, 3, 0x50, 0x3E, 0x4C, 0x75, 0xBA, 0x94, 0x31, 0x48, 0xF1, 0x8D, 0x94, 0x1E};
'static const uint8_t uart_rx_uuid[]   = {0x71, 0x3D, 0, 2, 0x50, 0x3E, 0x4C, 0x75, 0xBA, 0x94, 0x31, 0x48, 0xF1, 0x8D, 0x94, 0x1E};
'static const uint8_t uart_base_uuid_rev[] = {0x1E, 0x94, 0x8D, 0xF1, 0x48, 0x31, 0x94, 0xBA, 0x75, 0x4C, 0x3E, 0x50, 0, 0, 0x3D, 0x71};

End Sub
'------------------------------------------------ 

Sub Service_Create
	
	manager.Initialize("manager")
'event, Sub Manager_StateChanged will be rised

End Sub
'------------------------------------------------

Sub Service_Start (StartingIntent As Intent)

End Sub
'------------------------------------------------

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	
	Return True
	
End Sub
'------------------------------------------------

Sub Service_Destroy

End Sub
'------------------------------------------------

Public Sub Scan
	Log ("Scanning")
	ConnRetry = 0
	'manager.Scan(Null)
	manager.Scan2(Null,False)   'all devices, no duplicates
End Sub
'------------------------------------------------

public Sub stopScan
	Log ("scan stopped")
	manager.StopScan
End Sub
'------------------------------------------------

Public Sub ReadData
	' Read message on the data channel
	manager.ReadData2(MLDP_PRIVATE_SERVICE, MLDP_DATA_PRIVATE_CHAR)
End Sub
'------------------------------------------------

Public Sub SendStr(Data As String)  'CallSub2(BT_Service, "SendStr", "Chat test" & CR) 'identify app to RN4020.
                                    '	Public CR As String = Chr(13) & Chr(10)
		Log("Sending: " & Data)
	msgAll = Data
	msgAll = msgAll & CR_LF
	msgLen = msgAll.Length
	msgPtr=0
	
	writePkt
End Sub
'------------------------------------------------

Sub Manager_WriteComplete (Characteristic As String, Status As Int)
	If connected = False Then Return
		Log("Writecomplete: " & Characteristic)
		Log("Status=" & Status)
	writePkt
End Sub
'------------------------------------------------

Sub writePkt
' if the string to send is longer than 20 bytes (BLE limit) this breaks
' it down to multiple "packets" of 20 to complete the message. 
	If msgLen = 0 Then  Return    'meer dan 19 bytes werkt niet
	
	If msgLen > 20 Then
		msgPkt = msgAll.SubString2(msgPtr,msgPtr+20)
		msgPtr = msgPtr+20
		msgLen = msgLen -20
	Else
		msgPkt = msgAll.SubString(msgPtr)
		msgLen = 0
	End If

	Dim D() As Byte = msgPkt.GetBytes("UTF8")
	delay(125)	'125 sending multiple back to back packets fails without this delay.
	
manager.WriteData(MLDP_PRIVATE_SERVICE, MLDP_DATA_PRIVATE_CHAR, D)
	manager.SetNotify(MLDP_PRIVATE_SERVICE, MLDP_DATA_PRIVATE_CHAR, True)
	
End Sub
'------------------------------------------------

Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)'MLDP_PRIVATE_SERVICE
	Log("DA")
	Log(ServiceId)
	Log(Characteristics)
	CallSub3(Main, "DataAvailable", ServiceId, Characteristics)
End Sub
'------------------------------------------------

'Private MLDP_PRIVATE_SERVICE As String = "569a1101-b87f-490c-92cb-11ba5ea5167c"  'for LAIRD BL600, vSP "LT_UPASS"
'Private MLDP_DATA_PRIVATE_CHAR As String ="569a2001-b87f-490c-92cb-11ba5ea5167c"   'for LAIRD BL600, vSP "LT_UPASS"

'Public class VirtualSerialPortDevice extends BleBaseDeviceManager
'{
'	Private static final String TAG = "VirtualSerialPortDevice";
'
'	Public final static UUID VSP_SERVICE = UUID
'			.fromString("569a1101-b87f-490c-92cb-11ba5ea5167c");  'xxxxxxxxxxxx Disconnecting
'	/**
'	 * For receiving data from the remote device
'	 */
'	Public final static UUID VSP_CHAR_TX = UUID
'			.fromString("569a2000-b87f-490c-92cb-11ba5ea5167c");
'	/**
'	 * doe sending data To the remote device
'	 */
'	Public final static UUID VSP_CHAR_RX = UUID
'			.fromString("569a2001-b87f-490c-92cb-11ba5ea5167c");

'	Public final static UUID VSP_CHAR_MODEM_OUT = UUID
'			.fromString("569a2002-b87f-490c-92cb-11ba5ea5167c");

'	Public final static UUID VSP_CHAR_MODEM_IN = UUID
'			.fromString("569a2003-b87f-490c-92cb-11ba5ea5167c");
'

Public Sub Disconnect
	Log("Disconnecting")
	If connected Then   'Boolean
		manager.SetNotify(MLDP_PRIVATE_SERVICE, MLDP_DATA_PRIVATE_CHAR, False)
		manager.Disconnect
	End If
	
End Sub
'------------------------------------------------

Sub Manager_StateChanged (State As Int)  'will be raised at start
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"

			Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
						Log("BT State = Powered On")
						
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
			
	End Select
	CallSub(Main, "StateChanged")
End Sub
'------------------------------------------------

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData)
	ConnectedName = Name
	ConnId = Id
	If ConnectedName = Null Then
		Log("no name found")
		ConnectedName = "no name"
	End If
	
		If ConnId = "D5:9A:88:70:43:15" Then
	 manager.StopScan
		CallSub2(Main, "putStatus", "Connecting")
		manager.Connect2(ConnId,False)
		Log(ConnectedName & " connected")
		Return
		End If

'		If Name.Contains(Name0) Then
'	 manager.StopScan
'		CallSub2(Main, "putStatus", "Connecting")
'		manager.Connect2(ConnId,False)
'		Log(Name& " connected")
'		End If
'		
'		If Name.Contains(Name1) Then
'	 manager.StopScan
'		CallSub2(Main, "putStatus", "Connecting")
'		manager.Connect2(ConnId,False)
'		Log(Name& " connected")
'		End If
		
End Sub
'------------------------------------------------

'Sub BT_Connect (Id As String)
'	manager.StopScan
'	manager.Connect2(ConnId,False)
'End Sub
''------------------------------------------------

Sub Manager_Disconnected
	
	Log("Disconnected")
	connected = False
	TimeDiscon = DateTime.Now
	Log ("Connect duration = " & (TimeDiscon - TimeConnected) & " miliseconds")
	If (TimeDiscon - TimeConnected)< 400 Then	' if < 400 msec do a connect retry
		ConnRetry = ConnRetry + 1
		CallSub2(Main,"putStatus","Retry " & ConnRetry)
		If ConnRetry < 5 Then					' max of 5 retries
			Log ("Retry = " & ConnRetry)
			manager.Connect2(ConnId,False)
		End If
	End If
	
	CallSub(Main, "BT_Disconnected")
		
End Sub
'------------------------------------------------

Sub Manager_Connected (services As List)  'list my services in the log
	Log("Manager-Connected-EVENT")
	Dim List1 As List
List1.Initialize
List1.AddAll(services)
For i=0 To List1.Size-1
Log(List1.Get(i))
Next

	TimeConnected = DateTime.Now
	connected = True
	'CallSub(Main, "StateChanged")
	CallSub(Main, "BT_Connected")
End Sub
'------------------------------------------------

public Sub delay(ms As Int)  'delay between packets
	Dim temp As Int
	Dim futuretime As Long
	futuretime = DateTime.Now + ms
	Do While DateTime.Now < futuretime
		temp=temp+1   'dummy stuff, not used
	Loop
End Sub
'------------------------------------------------


