package rn4020.my_chat;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (processBA == null) {
			processBA = new BA(this.getApplicationContext(), null, null, "rn4020.my_chat", "rn4020.my_chat.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "rn4020.my_chat", "rn4020.my_chat.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "rn4020.my_chat.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _admin = null;
public static anywheresoftware.b4a.objects.collections.List _founddevices = null;
public static String _devname = "";
public static String _devmac = "";
public static anywheresoftware.b4a.objects.Timer _scantimer = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btndisconnect = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnscan = null;
public anywheresoftware.b4a.objects.LabelWrapper _lbl1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblstatus = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext1 = null;
public anywheresoftware.b4a.objects.EditTextWrapper _edittext2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnsend = null;
public anywheresoftware.b4a.objects.ButtonWrapper _btnexit = null;
public static boolean _userexit = false;
public static boolean _recdataflag = false;
public static byte _messagepntr = (byte)0;
public static byte _messagelength = (byte)0;
public static byte[] _message = null;
public static String _mldpmsg = "";
public static String _macaddr = "";
public static String _cr = "";
public static int _scanretry = 0;
public static int _scantimercount = 0;
public anywheresoftware.b4a.objects.LabelWrapper _lfile = null;
public static String _rcmess = "";
public rn4020.my_chat.bt_service _bt_service = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 70;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 72;BA.debugLine="Activity.LoadLayout(\"Main\")";
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 //BA.debugLineNum = 73;BA.debugLine="RecDataFlag = False";
_recdataflag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 74;BA.debugLine="Activity.Title=\"My_chat_RN4020\"";
mostCurrent._activity.setTitle(BA.ObjectToCharSequence("My_chat_RN4020"));
 //BA.debugLineNum = 75;BA.debugLine="userExit = False";
_userexit = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 76;BA.debugLine="BT_Service.ConnRetry = 0";
mostCurrent._bt_service._connretry = (int) (0);
 //BA.debugLineNum = 79;BA.debugLine="edittext1.Hint = \"Enter msg to send\"";
mostCurrent._edittext1.setHint("Enter msg to send");
 //BA.debugLineNum = 80;BA.debugLine="edittext1.Text = \"Enter msg to send\"";
mostCurrent._edittext1.setText(BA.ObjectToCharSequence("Enter msg to send"));
 //BA.debugLineNum = 81;BA.debugLine="edittext1.Color=Colors.White";
mostCurrent._edittext1.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 82;BA.debugLine="edittext1.HintColor=Colors.LightGray";
mostCurrent._edittext1.setHintColor(anywheresoftware.b4a.keywords.Common.Colors.LightGray);
 //BA.debugLineNum = 83;BA.debugLine="edittext1.TextColor=Colors.Black";
mostCurrent._edittext1.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 84;BA.debugLine="edittext2.Color=Colors.White";
mostCurrent._edittext2.setColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 85;BA.debugLine="edittext2.TextColor=Colors.Black";
mostCurrent._edittext2.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 //BA.debugLineNum = 87;BA.debugLine="btnDisconnect.Enabled=False";
mostCurrent._btndisconnect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 88;BA.debugLine="btnSend.Enabled=False";
mostCurrent._btnsend.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 89;BA.debugLine="Lfile.Text=\"My_chat_RN4020\"";
mostCurrent._lfile.setText(BA.ObjectToCharSequence("My_chat_RN4020"));
 //BA.debugLineNum = 92;BA.debugLine="scanTimer.Initialize(\"scanTimer\",100)	' ten ticks";
_scantimer.Initialize(processBA,"scanTimer",(long) (100));
 //BA.debugLineNum = 93;BA.debugLine="scanTimer.Enabled = False";
_scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 94;BA.debugLine="scanRetry = 0";
_scanretry = (int) (0);
 //BA.debugLineNum = 96;BA.debugLine="lblStatus.Text = \"Not connected\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Not connected"));
 //BA.debugLineNum = 101;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 102;BA.debugLine="admin.Initialize(\"admin\")";
_admin.Initialize(processBA,"admin");
 };
 //BA.debugLineNum = 106;BA.debugLine="StartService(BT_Service)     'buttons will be enab";
anywheresoftware.b4a.keywords.Common.StartService(processBA,(Object)(mostCurrent._bt_service.getObject()));
 //BA.debugLineNum = 108;BA.debugLine="End Sub";
return "";
}
public static void  _activity_pause(boolean _userclosed) throws Exception{
ResumableSub_Activity_Pause rsub = new ResumableSub_Activity_Pause(null,_userclosed);
rsub.resume(processBA, null);
}
public static class ResumableSub_Activity_Pause extends BA.ResumableSub {
public ResumableSub_Activity_Pause(rn4020.my_chat.main parent,boolean _userclosed) {
this.parent = parent;
this._userclosed = _userclosed;
}
rn4020.my_chat.main parent;
boolean _userclosed;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 131;BA.debugLine="If UserClosed Then    'if True";
if (true) break;

case 1:
//if
this.state = 8;
if (_userclosed) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 132;BA.debugLine="userExit = True   'again a Boolean ???";
parent._userexit = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 133;BA.debugLine="scanTimer.Enabled=False   'kill timer";
parent._scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 134;BA.debugLine="CallSub(BT_Service, \"Disconnect\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(parent.mostCurrent._bt_service.getObject()),"Disconnect");
 //BA.debugLineNum = 135;BA.debugLine="Do While BT_Service.connected = True	'=Proc";
if (true) break;

case 4:
//do while
this.state = 7;
while (parent.mostCurrent._bt_service._connected==anywheresoftware.b4a.keywords.Common.True) {
this.state = 6;
if (true) break;
}
if (true) break;

case 6:
//C
this.state = 4;
 //BA.debugLineNum = 136;BA.debugLine="Sleep(50)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (50));
this.state = 9;
return;
case 9:
//C
this.state = 4;
;
 if (true) break;

case 7:
//C
this.state = 8;
;
 //BA.debugLineNum = 138;BA.debugLine="SetBToff";
_setbtoff();
 //BA.debugLineNum = 140;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 if (true) break;

case 8:
//C
this.state = -1;
;
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 111;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 114;BA.debugLine="End Sub";
return "";
}
public static void  _bcloseall_click() throws Exception{
ResumableSub_Bcloseall_Click rsub = new ResumableSub_Bcloseall_Click(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_Bcloseall_Click extends BA.ResumableSub {
public ResumableSub_Bcloseall_Click(rn4020.my_chat.main parent) {
this.parent = parent;
}
rn4020.my_chat.main parent;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 373;BA.debugLine="Activity_Pause(True)   'I have clicked the exit-bu";
_activity_pause(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 375;BA.debugLine="If admin.IsEnabled Then	admin.Disable";
if (true) break;

case 1:
//if
this.state = 6;
if (parent._admin.IsEnabled()) { 
this.state = 3;
;}if (true) break;

case 3:
//C
this.state = 6;
parent._admin.Disable();
if (true) break;

case 6:
//C
this.state = 7;
;
 //BA.debugLineNum = 377;BA.debugLine="Do While admin.IsEnabled = True	'=Process_Global,";
if (true) break;

case 7:
//do while
this.state = 10;
while (parent._admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.True) {
this.state = 9;
if (true) break;
}
if (true) break;

case 9:
//C
this.state = 7;
 //BA.debugLineNum = 378;BA.debugLine="Sleep(50)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (50));
this.state = 11;
return;
case 11:
//C
this.state = 7;
;
 if (true) break;

case 10:
//C
this.state = -1;
;
 //BA.debugLineNum = 381;BA.debugLine="ExitApplication";
anywheresoftware.b4a.keywords.Common.ExitApplication();
 //BA.debugLineNum = 383;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _bt_connected() throws Exception{
ResumableSub_BT_Connected rsub = new ResumableSub_BT_Connected(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_BT_Connected extends BA.ResumableSub {
public ResumableSub_BT_Connected(rn4020.my_chat.main parent) {
this.parent = parent;
}
rn4020.my_chat.main parent;
String _msgout = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 227;BA.debugLine="Dim msgOut As String";
_msgout = "";
 //BA.debugLineNum = 229;BA.debugLine="If BT_Service.connected Then  'if flag is 1";
if (true) break;

case 1:
//if
this.state = 4;
if (parent.mostCurrent._bt_service._connected) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 230;BA.debugLine="Log(\"BT connected\")";
anywheresoftware.b4a.keywords.Common.Log("BT connected");
 //BA.debugLineNum = 231;BA.debugLine="scanTimer.Enabled = False";
parent._scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 232;BA.debugLine="btnDisconnect.Enabled = True";
parent.mostCurrent._btndisconnect.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 233;BA.debugLine="btnScan.Enabled = False";
parent.mostCurrent._btnscan.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 234;BA.debugLine="btnSend.Enabled = True";
parent.mostCurrent._btnsend.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 235;BA.debugLine="lblStatus.Text = \"Connected: \" & BT_Service.C";
parent.mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Connected: "+parent.mostCurrent._bt_service._connectedname));
 //BA.debugLineNum = 236;BA.debugLine="RecDataFlag = False";
parent._recdataflag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 237;BA.debugLine="MessagePntr = 0";
parent._messagepntr = (byte) (0);
 //BA.debugLineNum = 238;BA.debugLine="MessageLength = 64";
parent._messagelength = (byte) (64);
 //BA.debugLineNum = 244;BA.debugLine="Sleep(250)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (250));
this.state = 5;
return;
case 5:
//C
this.state = 4;
;
 //BA.debugLineNum = 245;BA.debugLine="msgOut = \"MyTest\"";
_msgout = "MyTest";
 if (true) break;

case 4:
//C
this.state = -1;
;
 //BA.debugLineNum = 251;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _bt_disconnected() throws Exception{
 //BA.debugLineNum = 209;BA.debugLine="Public Sub BT_Disconnected";
 //BA.debugLineNum = 210;BA.debugLine="If BT_Service.connected=False And userExit = Fals";
if (mostCurrent._bt_service._connected==anywheresoftware.b4a.keywords.Common.False && _userexit==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 211;BA.debugLine="scanTimer.Enabled = False";
_scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 212;BA.debugLine="btnScan.Enabled=True";
mostCurrent._btnscan.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 213;BA.debugLine="btnDisconnect.Enabled=False";
mostCurrent._btndisconnect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 214;BA.debugLine="btnSend.Enabled=False";
mostCurrent._btnsend.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 215;BA.debugLine="lblStatus.Text = \"Not connected\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Not connected"));
 };
 //BA.debugLineNum = 218;BA.debugLine="End Sub";
return "";
}
public static String  _btnclr_click() throws Exception{
 //BA.debugLineNum = 262;BA.debugLine="Sub btnClr_Click";
 //BA.debugLineNum = 263;BA.debugLine="edittext1.Text=\"\"";
mostCurrent._edittext1.setText(BA.ObjectToCharSequence(""));
 //BA.debugLineNum = 264;BA.debugLine="End Sub";
return "";
}
public static String  _btnclr2_click() throws Exception{
 //BA.debugLineNum = 386;BA.debugLine="Sub BtnClr2_Click";
 //BA.debugLineNum = 387;BA.debugLine="edittext2.Text=\"\"";
mostCurrent._edittext2.setText(BA.ObjectToCharSequence(""));
 //BA.debugLineNum = 388;BA.debugLine="End Sub'Here's my RN4020 setup:  DIT WERKT";
return "";
}
public static String  _btndisconnect_click() throws Exception{
 //BA.debugLineNum = 277;BA.debugLine="Sub btnDisconnect_Click";
 //BA.debugLineNum = 278;BA.debugLine="scanTimer.Enabled=False";
_scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 279;BA.debugLine="CallSub(BT_Service, \"Disconnect\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(mostCurrent._bt_service.getObject()),"Disconnect");
 //BA.debugLineNum = 282;BA.debugLine="End Sub";
return "";
}
public static String  _btnexit_click() throws Exception{
 //BA.debugLineNum = 285;BA.debugLine="Sub btnExit_Click";
 //BA.debugLineNum = 286;BA.debugLine="Activity_Pause(True)   'I have clicked the exit-b";
_activity_pause(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 287;BA.debugLine="End Sub";
return "";
}
public static String  _btnscan_click() throws Exception{
 //BA.debugLineNum = 267;BA.debugLine="Sub btnScan_Click";
 //BA.debugLineNum = 268;BA.debugLine="btnScan.Enabled=False";
mostCurrent._btnscan.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 269;BA.debugLine="lblStatus.Text = \"Scanning\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Scanning"));
 //BA.debugLineNum = 270;BA.debugLine="scanRetry=0";
_scanretry = (int) (0);
 //BA.debugLineNum = 271;BA.debugLine="scanTimerCount = 0";
_scantimercount = (int) (0);
 //BA.debugLineNum = 272;BA.debugLine="scanTimer.Enabled=True";
_scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 273;BA.debugLine="CallSub(BT_Service, \"Scan\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(mostCurrent._bt_service.getObject()),"Scan");
 //BA.debugLineNum = 274;BA.debugLine="End Sub";
return "";
}
public static String  _btnsend_click() throws Exception{
String _msgout = "";
 //BA.debugLineNum = 254;BA.debugLine="Sub btnSend_Click";
 //BA.debugLineNum = 256;BA.debugLine="Dim msgOut As String";
_msgout = "";
 //BA.debugLineNum = 257;BA.debugLine="msgOut = edittext1.Text";
_msgout = mostCurrent._edittext1.getText();
 //BA.debugLineNum = 258;BA.debugLine="CallSub2(BT_Service,\"sendStr\",msgOut)  ' & CR) 'a";
anywheresoftware.b4a.keywords.Common.CallSubNew2(processBA,(Object)(mostCurrent._bt_service.getObject()),"sendStr",(Object)(_msgout));
 //BA.debugLineNum = 259;BA.debugLine="End Sub";
return "";
}
public static String  _buildmessage(byte[] _data) throws Exception{
byte _c = (byte)0;
int _i = 0;
int _x = 0;
 //BA.debugLineNum = 300;BA.debugLine="Sub BuildMessage(Data() As Byte)	' this assembles";
 //BA.debugLineNum = 301;BA.debugLine="Log(\"BuildMessage \"&Data.Length)";
anywheresoftware.b4a.keywords.Common.Log("BuildMessage "+BA.NumberToString(_data.length));
 //BA.debugLineNum = 304;BA.debugLine="Log(Data.Length)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_data.length));
 //BA.debugLineNum = 305;BA.debugLine="Dim c As Byte";
_c = (byte)0;
 //BA.debugLineNum = 307;BA.debugLine="For i=0 To Data.Length-1";
{
final int step4 = 1;
final int limit4 = (int) (_data.length-1);
_i = (int) (0) ;
for (;(step4 > 0 && _i <= limit4) || (step4 < 0 && _i >= limit4) ;_i = ((int)(0 + _i + step4))  ) {
 //BA.debugLineNum = 309;BA.debugLine="c=Data(i)";
_c = _data[_i];
 //BA.debugLineNum = 312;BA.debugLine="rcmess = rcmess & Chr(c)";
mostCurrent._rcmess = mostCurrent._rcmess+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (_c)));
 //BA.debugLineNum = 313;BA.debugLine="If c=10 Then   'last byte, from myCR at en";
if (_c==10) { 
 //BA.debugLineNum = 314;BA.debugLine="edittext2.Text = edittext2.Text & rcm";
mostCurrent._edittext2.setText(BA.ObjectToCharSequence(mostCurrent._edittext2.getText()+mostCurrent._rcmess));
 //BA.debugLineNum = 315;BA.debugLine="edittext2.SelectionStart = edittext2.";
mostCurrent._edittext2.setSelectionStart(mostCurrent._edittext2.getText().length());
 //BA.debugLineNum = 316;BA.debugLine="Log(rcmess.Length & \" bytes, CRLF in\"";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(mostCurrent._rcmess.length())+" bytes, CRLF in");
 //BA.debugLineNum = 317;BA.debugLine="Log(\"----------------------------\")";
anywheresoftware.b4a.keywords.Common.Log("----------------------------");
 //BA.debugLineNum = 318;BA.debugLine="rcmess = \"\"";
mostCurrent._rcmess = "";
 };
 }
};
 //BA.debugLineNum = 323;BA.debugLine="Return";
if (true) return "";
 //BA.debugLineNum = 332;BA.debugLine="If Not(RecDataFlag) Then		' or several bytes in a";
if (anywheresoftware.b4a.keywords.Common.Not(_recdataflag)) { 
 //BA.debugLineNum = 333;BA.debugLine="RecDataFlag = True			' I use a Line Feed as an e";
_recdataflag = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 334;BA.debugLine="MessagePntr = 0";
_messagepntr = (byte) (0);
 //BA.debugLineNum = 335;BA.debugLine="MessageLength = 64";
_messagelength = (byte) (64);
 //BA.debugLineNum = 336;BA.debugLine="MldpMsg=\"\"";
mostCurrent._mldpmsg = "";
 };
 //BA.debugLineNum = 339;BA.debugLine="If RecDataFlag Then";
if (_recdataflag) { 
 //BA.debugLineNum = 340;BA.debugLine="For x = 0 To Data.Length-1";
{
final int step23 = 1;
final int limit23 = (int) (_data.length-1);
_x = (int) (0) ;
for (;(step23 > 0 && _x <= limit23) || (step23 < 0 && _x >= limit23) ;_x = ((int)(0 + _x + step23))  ) {
 //BA.debugLineNum = 341;BA.debugLine="Message(MessagePntr) = Data(x)";
_message[(int) (_messagepntr)] = _data[_x];
 //BA.debugLineNum = 342;BA.debugLine="MldpMsg = MldpMsg & Chr(Data(x))";
mostCurrent._mldpmsg = mostCurrent._mldpmsg+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (_data[_x])));
 //BA.debugLineNum = 343;BA.debugLine="If(Message(MessagePntr)=10) Then		' did we rece";
if ((_message[(int) (_messagepntr)]==10)) { 
 //BA.debugLineNum = 344;BA.debugLine="MessageLength = MldpMsg.Length";
_messagelength = (byte) (mostCurrent._mldpmsg.length());
 //BA.debugLineNum = 345;BA.debugLine="MessagePntr=MessageLength+1";
_messagepntr = (byte) (_messagelength+1);
 };
 }
};
 //BA.debugLineNum = 349;BA.debugLine="If MessagePntr >= MessageLength Then";
if (_messagepntr>=_messagelength) { 
 //BA.debugLineNum = 350;BA.debugLine="RecDataFlag = False";
_recdataflag = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 351;BA.debugLine="ServiceMessage";
_servicemessage();
 };
 };
 //BA.debugLineNum = 356;BA.debugLine="End Sub";
return "";
}
public static String  _dataavailable(String _service,anywheresoftware.b4a.objects.collections.Map _characteristics) throws Exception{
String _id = "";
 //BA.debugLineNum = 290;BA.debugLine="Sub DataAvailable (Service As String, Characterist";
 //BA.debugLineNum = 291;BA.debugLine="Log(\"Main DA\")";
anywheresoftware.b4a.keywords.Common.Log("Main DA");
 //BA.debugLineNum = 292;BA.debugLine="For Each id As String In Characteristics.Keys";
{
final anywheresoftware.b4a.BA.IterableList group2 = _characteristics.Keys();
final int groupLen2 = group2.getSize()
;int index2 = 0;
;
for (; index2 < groupLen2;index2++){
_id = BA.ObjectToString(group2.Get(index2));
 //BA.debugLineNum = 293;BA.debugLine="Log (\"ID=\" & id)";
anywheresoftware.b4a.keywords.Common.Log("ID="+_id);
 //BA.debugLineNum = 294;BA.debugLine="BuildMessage(Characteristics.Get(id))";
_buildmessage((byte[])(_characteristics.Get((Object)(_id))));
 }
};
 //BA.debugLineNum = 297;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 37;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 39;BA.debugLine="Dim btnDisconnect As Button";
mostCurrent._btndisconnect = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim btnScan As Button";
mostCurrent._btnscan = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Dim lbl1 As Label";
mostCurrent._lbl1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Dim lblStatus As Label";
mostCurrent._lblstatus = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 43;BA.debugLine="Dim edittext1 As EditText";
mostCurrent._edittext1 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 44;BA.debugLine="Dim edittext2 As EditText";
mostCurrent._edittext2 = new anywheresoftware.b4a.objects.EditTextWrapper();
 //BA.debugLineNum = 45;BA.debugLine="Dim btnSend As Button";
mostCurrent._btnsend = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 46;BA.debugLine="Dim btnExit As Button";
mostCurrent._btnexit = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 47;BA.debugLine="Dim userExit As Boolean";
_userexit = false;
 //BA.debugLineNum = 51;BA.debugLine="Private RecDataFlag As Boolean";
_recdataflag = false;
 //BA.debugLineNum = 52;BA.debugLine="Private MessagePntr As Byte";
_messagepntr = (byte)0;
 //BA.debugLineNum = 53;BA.debugLine="Private MessageLength As Byte";
_messagelength = (byte)0;
 //BA.debugLineNum = 54;BA.debugLine="Private Message(256) As Byte";
_message = new byte[(int) (256)];
;
 //BA.debugLineNum = 55;BA.debugLine="Public MldpMsg As String";
mostCurrent._mldpmsg = "";
 //BA.debugLineNum = 56;BA.debugLine="Public MacAddr As String";
mostCurrent._macaddr = "";
 //BA.debugLineNum = 57;BA.debugLine="Public CR As String = Chr(13) & Chr(10)";
mostCurrent._cr = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (13)))+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (10)));
 //BA.debugLineNum = 58;BA.debugLine="Dim scanRetry As Int";
_scanretry = 0;
 //BA.debugLineNum = 59;BA.debugLine="Dim scanTimerCount As Int";
_scantimercount = 0;
 //BA.debugLineNum = 61;BA.debugLine="Private Lfile As Label";
mostCurrent._lfile = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 65;BA.debugLine="Dim rcmess As String  = \"\"";
mostCurrent._rcmess = "";
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
bt_service._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim admin As BluetoothAdmin";
_admin = new anywheresoftware.b4a.objects.Serial.BluetoothAdmin();
 //BA.debugLineNum = 20;BA.debugLine="Dim foundDevices As List";
_founddevices = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 21;BA.debugLine="Dim DevName As String  :DevName=\"\"";
_devname = "";
 //BA.debugLineNum = 21;BA.debugLine="Dim DevName As String  :DevName=\"\"";
_devname = "";
 //BA.debugLineNum = 22;BA.debugLine="Dim DevMac As String   :DevMac=\"\"";
_devmac = "";
 //BA.debugLineNum = 22;BA.debugLine="Dim DevMac As String   :DevMac=\"\"";
_devmac = "";
 //BA.debugLineNum = 23;BA.debugLine="Dim scanTimer As Timer";
_scantimer = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 25;BA.debugLine="End Sub";
return "";
}
public static String  _putstatus(String _stat) throws Exception{
 //BA.debugLineNum = 221;BA.debugLine="Sub putStatus (stat As String)";
 //BA.debugLineNum = 222;BA.debugLine="lblStatus.Text = stat";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence(_stat));
 //BA.debugLineNum = 223;BA.debugLine="End Sub";
return "";
}
public static String  _scantimer_tick() throws Exception{
 //BA.debugLineNum = 117;BA.debugLine="Sub scanTimer_Tick";
 //BA.debugLineNum = 118;BA.debugLine="scanTimerCount = scanTimerCount + 1";
_scantimercount = (int) (_scantimercount+1);
 //BA.debugLineNum = 119;BA.debugLine="If scanTimerCount = 20 Then";
if (_scantimercount==20) { 
 //BA.debugLineNum = 120;BA.debugLine="scanTimer.Enabled = False";
_scantimer.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 121;BA.debugLine="CallSub(BT_Service, \"stopScan\")";
anywheresoftware.b4a.keywords.Common.CallSubNew(processBA,(Object)(mostCurrent._bt_service.getObject()),"stopScan");
 //BA.debugLineNum = 122;BA.debugLine="lblStatus.Text = \"Scan stopped\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Scan stopped"));
 //BA.debugLineNum = 123;BA.debugLine="btnScan.Enabled = True";
mostCurrent._btnscan.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 };
 //BA.debugLineNum = 126;BA.debugLine="End Sub";
return "";
}
public static String  _servicemessage() throws Exception{
 //BA.debugLineNum = 359;BA.debugLine="Sub ServiceMessage";
 //BA.debugLineNum = 361;BA.debugLine="Log(\"Msg received: \" & MldpMsg)";
anywheresoftware.b4a.keywords.Common.Log("Msg received: "+mostCurrent._mldpmsg);
 //BA.debugLineNum = 363;BA.debugLine="edittext2.Text = edittext2.Text & MldpMsg  'show m";
mostCurrent._edittext2.setText(BA.ObjectToCharSequence(mostCurrent._edittext2.getText()+mostCurrent._mldpmsg));
 //BA.debugLineNum = 364;BA.debugLine="edittext2.SelectionStart = edittext2.Text.Length";
mostCurrent._edittext2.setSelectionStart(mostCurrent._edittext2.getText().length());
 //BA.debugLineNum = 367;BA.debugLine="MldpMsg = \"\"";
mostCurrent._mldpmsg = "";
 //BA.debugLineNum = 369;BA.debugLine="End Sub";
return "";
}
public static void  _setbtoff() throws Exception{
ResumableSub_SetBToff rsub = new ResumableSub_SetBToff(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_SetBToff extends BA.ResumableSub {
public ResumableSub_SetBToff(rn4020.my_chat.main parent) {
this.parent = parent;
}
rn4020.my_chat.main parent;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 163;BA.debugLine="If admin.IsEnabled = True Then    'check if BT-ada";
if (true) break;

case 1:
//if
this.state = 8;
if (parent._admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.True) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 164;BA.debugLine="admin.Disable      'enable BT, and if NOT, m";
parent._admin.Disable();
 //BA.debugLineNum = 166;BA.debugLine="ToastMessageShow(\"Enabling Blue";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Enabling Bluetooth adapter..."),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 167;BA.debugLine="Do While admin.IsEnabled = True	'=Process_Gl";
if (true) break;

case 4:
//do while
this.state = 7;
while (parent._admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.True) {
this.state = 6;
if (true) break;
}
if (true) break;

case 6:
//C
this.state = 4;
 //BA.debugLineNum = 168;BA.debugLine="Sleep(50)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (50));
this.state = 9;
return;
case 9:
//C
this.state = 4;
;
 if (true) break;

case 7:
//C
this.state = 8;
;
 if (true) break;

case 8:
//C
this.state = -1;
;
 //BA.debugLineNum = 173;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static void  _setbton() throws Exception{
ResumableSub_SetBTon rsub = new ResumableSub_SetBTon(null);
rsub.resume(processBA, null);
}
public static class ResumableSub_SetBTon extends BA.ResumableSub {
public ResumableSub_SetBTon(rn4020.my_chat.main parent) {
this.parent = parent;
}
rn4020.my_chat.main parent;

@Override
public void resume(BA ba, Object[] result) throws Exception{

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = 1;
 //BA.debugLineNum = 148;BA.debugLine="If admin.IsEnabled = False Then    'check if BT-ad";
if (true) break;

case 1:
//if
this.state = 8;
if (parent._admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
this.state = 3;
}if (true) break;

case 3:
//C
this.state = 4;
 //BA.debugLineNum = 149;BA.debugLine="admin.Enable      'enable BT, and if NOT, me";
parent._admin.Enable();
 //BA.debugLineNum = 151;BA.debugLine="ToastMessageShow(\"Enabling Blue";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(BA.ObjectToCharSequence("Enabling Bluetooth adapter..."),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 152;BA.debugLine="Do While admin.IsEnabled = False	'=Process_G";
if (true) break;

case 4:
//do while
this.state = 7;
while (parent._admin.IsEnabled()==anywheresoftware.b4a.keywords.Common.False) {
this.state = 6;
if (true) break;
}
if (true) break;

case 6:
//C
this.state = 4;
 //BA.debugLineNum = 153;BA.debugLine="Sleep(50)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,this,(int) (50));
this.state = 9;
return;
case 9:
//C
this.state = 4;
;
 if (true) break;

case 7:
//C
this.state = 8;
;
 if (true) break;

case 8:
//C
this.state = -1;
;
 //BA.debugLineNum = 158;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _statechanged() throws Exception{
 //BA.debugLineNum = 176;BA.debugLine="Public Sub StateChanged";
 //BA.debugLineNum = 177;BA.debugLine="If BT_Service.currentStateText = \"POWERED OFF\" Th";
if ((mostCurrent._bt_service._currentstatetext).equals("POWERED OFF")) { 
 //BA.debugLineNum = 178;BA.debugLine="lblStatus.Text = \"Please enable Bluetooth\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Please enable Bluetooth"));
 //BA.debugLineNum = 181;BA.debugLine="btnDisconnect.Enabled = False";
mostCurrent._btndisconnect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 182;BA.debugLine="btnScan.Enabled = False";
mostCurrent._btnscan.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 183;BA.debugLine="btnSend.Enabled = False";
mostCurrent._btnsend.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 184;BA.debugLine="SetBTon";
_setbton();
 }else if((mostCurrent._bt_service._currentstatetext).equals("POWERED ON")) { 
 //BA.debugLineNum = 187;BA.debugLine="lblStatus.Text = \"Press Scan to start\"";
mostCurrent._lblstatus.setText(BA.ObjectToCharSequence("Press Scan to start"));
 //BA.debugLineNum = 189;BA.debugLine="btnDisconnect.Enabled = True";
mostCurrent._btndisconnect.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 190;BA.debugLine="btnScan.Enabled = True";
mostCurrent._btnscan.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 191;BA.debugLine="btnSend.Enabled = False";
mostCurrent._btnsend.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 192;BA.debugLine="btnDisconnect.Enabled = False";
mostCurrent._btndisconnect.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 193;BA.debugLine="btnScan_Click";
_btnscan_click();
 };
 //BA.debugLineNum = 197;BA.debugLine="End Sub";
return "";
}
}
